// serial.c and io.c modified for LPC2106 at 8 MHz
#include <ARM/philips/lpc210x.h>
#include <stdio.h>

/* This assumes a 14.7456 MHz clock. If not, you'll need to change the
 * baud rate calculation.
 */
void setbaud(int baud)
{
	// Default VPB clock is 1/4 processor clock, or 3686400 Hz.
	// Baud divisor is VPB/16*baud, or 230400/baud
    int baudDiv = 230400/baud;

    UART0_LCR = 0x00000083;	 	    // Enable the divisor
	
    UART0_DLM = baudDiv >> 8;	    // Divisor latch MSB 
    UART0_DLL = baudDiv & 0xFF;     // Divisor latch LSB 
    UART0_LCR = 0x00000003;  	    // 8 bits, no parity, 1 stop bit
}

int getchar(void)
{
    while (!(UART0_LSR & 0x01))
	{
	}

	return UART0_RBR;
}

int putchar(char c)
{
	if (c == '\n')
		putchar('\r');

    while (!(UART0_LSR & 0x20))
	{
	} 
  
    UART0_THR = c;
	return c;
}

